import java.lang.reflect.Constructor;

public class DestructorSingleton {
    public static void main(String[] args) {
        ExempleSingleton instanceOne = ExempleSingleton.getInstance("Hola");
        ExempleSingleton instanceTwo = getNewDestroyedInstance("Adeu");

        System.out.println("Aquest exemple triga una estona a iniciar l'objecte,");
        System.out.println("per mostrar que aconsegueix destruir el singleton");
        System.out.println("i obtenim instàncies diferents (Hola / Adeu)");

        System.out.println(instanceOne.value);
        System.out.println(instanceTwo.value);
    }

    static ExempleSingleton getNewDestroyedInstance (String value) {
        ExempleSingleton result = null;
        try {
            Constructor[] constructors = ExempleSingleton.class.getDeclaredConstructors();
            for (Constructor constructor : constructors) {
                //Below code will destroy the singleton pattern
                constructor.setAccessible(true);
                result = (ExempleSingleton) constructor.newInstance(value);
                break;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }
}
